﻿Imports System.Drawing.Color
Imports System.Reflection.MethodBase
Imports ErrorLog
Imports ErrorLog.LogStates
Imports Windows.UI.Xaml.Media

Public Class ucWindow
    Private sModule As String = "ucWindow"
    Public Event ErrorRaised(oDetail As ErrorDetail)
    Public Event MouseHovering(oWindow As ucWindow)
    Public Event MouseLeft(oWindow As ucWindow)

    Public ProcessID As Process
    Public Title As String
    Public HWnd As Integer
    Private oIcon As Icon

    Public Sub New(oProcess As Process)
        Try
            InitializeComponent()                                       ' This call is required by the designer.
            ProcessID = oProcess
            lblText.Text = oProcess.MainWindowTitle                     ' Set the title
            Title = lblText.Text
            HWnd = oProcess.MainWindowHandle
            Try
                For Each oModule As ProcessModule In oProcess.Modules   ' Get EXE and copy Icon
                    If oModule.FileName.ToLower.EndsWith(".exe") Then
                        oIcon = Icon.ExtractAssociatedIcon(oModule.FileName)
                        picIcon.Image = oIcon.ToBitmap                  ' Extract icon & display
                        Exit For                                        ' Don't need to do this more than once
                    End If
                Next
            Catch                                                       ' Catch win32expection if unable to access module list
            End Try

        Catch ex As Exception
            Throw New Exception(sModule & "." & GetCurrentMethod().Name & ":" & ex.Message, ex)
        End Try
    End Sub

    Private Sub ucWindow_Click(sender As Object, e As EventArgs) Handles Me.Click, picIcon.Click, lblText.Click
        Try
            AppActivate(ProcessID.MainWindowTitle)
        Catch ex As Exception
            Throw New Exception(sModule & "." & GetCurrentMethod().Name & ":" & ex.Message, ex)
        End Try
    End Sub

    Private Sub ucWindow_Load(sender As Object, e As EventArgs) Handles Me.Load
        Try
            Me.BackColor = Color.Transparent
            picIcon.BackColor = Color.Transparent
            pnlLeft.BackColor = Color.Transparent
            pnlText.BackColor = Color.Transparent
            lblText.BackColor = Color.Transparent
        Catch ex As Exception
            Throw New Exception(sModule & "." & GetCurrentMethod().Name & ":" & ex.Message, ex)
        End Try
    End Sub

    Private Sub picIcon_MouseHover(sender As Object, e As EventArgs) Handles picIcon.MouseHover, lblText.MouseHover
        RaiseEvent MouseHovering(Me)
    End Sub

    Private Sub picIcon_MouseLeave(sender As Object, e As EventArgs) Handles picIcon.MouseLeave, lblText.MouseLeave
        RaiseEvent MouseLeft(Me)
    End Sub
End Class
